Lorene::Star_bhns Class Reference
Stars and black holes

Class for stars in black hole-neutron star binaries. More...

`#include <star_bhns.h>`

Inheritance diagram for Lorene::Star_bhns:

## Public Member Functions

| Star_bhns (Map &mp_i, int nzet_i, const Eos &eos_i, bool irrot_i)
| Standard constructor.
| Star_bhns (const Star_bhns &)
| Copy constructor.
| Star_bhns (Map &mp_i, const Eos &eos_i, FILE *fich)
| Constructor from a file (see `sauve(FILE*)` ).
virtual | ~Star_bhns ()
| Destructor.
void | operator= (const Star_bhns &)
| Assignment to another Star_bhns.
Scalar & | set_pot_centri ()
| Read/write the centrifugal potential.
Scalar & | set_lapconf_auto ()
| Read/write of the lapconf function generated by the neutron star.
Scalar & | set_lapconf_comp ()
| Read/write of the lapconf function generated by the companion black hole.
Vector & | set_shift_auto ()
| Read/write of the shift vector generated by the neutron star.
Vector & | set_shift_comp ()
| Read/write of the shift vector generated by the companion black hole.
Scalar & | set_confo_auto ()
| Read/write of the conformal factor generated by the neutron star.
Scalar & | set_confo_comp ()
| Read/write of the conformal factor generated by the companion black hole.
bool | is_irrotational () const
| Returns `true` for an irrotational motion, `false` for a corotating one.
const Scalar & | get_psi0 () const
| Returns the non-translational part of the velocity potential.
const Vector & | get_d_psi () const
| Returns the covariant derivative of the velocity potential (Spherical components with respect to the mapping of the star).
const Vector & | get_wit_w () const
| Returns the spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.
const Scalar & | get_loggam () const
| Returns the logarithm of the Lorentz factor between the fluid and the co-orbiting observer.
const Vector & | get_bsn () const
| Returns the shift vector, divided by N , of the rotating coordinates, .
const Scalar & | get_gam () const
| Returns the Lorentz factor gam.
const Scalar & | get_gam0 () const
| Returns the Lorentz factor gam0.
const Scalar & | get_pot_centri () const
| Returns the centrifugal potential.
const Scalar & | get_lapconf_auto () const
| Returns the part of the lapconf function generated by the star.
const Scalar & | get_lapconf_comp () const
| Returns the part of the lapconf function generated by the companion black hole.
const Scalar & | get_lapconf_tot () const
| Returns the total lapconf function.
const Scalar & | get_lapse_auto () const
const Scalar & | get_lapse_tot () const
| Returns the total lapse function.
const Vector & | get_d_lapconf_auto () const
| Returns the derivative of the lapse function generated by the star.
const Vector & | get_d_lapconf_comp () const
| Returns the derivative of the lapse function generated by the companion black hole.
const Vector & | get_shift_auto () const
| Returns the part of the shift vector generated by the star.
const Vector & | get_shift_comp () const
| Returns the part of the shift vector generated by the companion black hole.
const Vector & | get_shift_tot () const
| Returns the part total shift vector.
const Tensor & | get_d_shift_auto () const
| Returns the derivative of the shift vector generated by the star.
const Tensor & | get_d_shift_comp () const
| Returns the derivative of the shift vector generated by the companion black hole.
const Scalar & | get_confo_auto () const
| Returns the part of the conformal factor generated by the star.
const Scalar & | get_confo_comp () const
| Returns the part of the conformal factor generated by the companion black hole.
const Scalar & | get_confo_tot () const
| Returns the total conformal factor.
const Vector & | get_d_confo_auto () const
| Returns the derivative of the conformal factor generated by the star.
const Vector & | get_d_confo_comp () const
| Returns the derivative of the conformal factor generated by the companion black hole.
const Scalar & | get_psi4 () const
| Returns the fourth power of the total conformal factor.
const Sym_tensor & | get_taij_auto () const
| Returns the part of the extrinsic curvature tensor generated by the neutron star part.
const Scalar & | get_taij_quad_auto () const
| Returns the part of the scalar generated by .
virtual void | sauve (FILE *) const
| Save in a file.
virtual double | mass_b () const
| Baryon mass.
virtual double | mass_b_bhns (bool kerrschild, const double &mass_bh, const double &sepa) const
virtual double | mass_g () const
| Gravitational mass.
virtual double | mass_g_bhns () const
void | hydro_euler_bhns (bool kerrschild, const double &mass_bh, const double &sepa)
| Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame, as well as `wit_w` and `loggam` .
void | update_metric_bhns (const Hole_bhns &hole, const Star_bhns &star_prev, double relax)
| Computes metric coefficients from known potentials with relaxation when the companion is a black hole.
void | update_met_der_comp_bhns (const Hole_bhns &hole)
| Computes derivative of metric quantities from the companion black hole.
void | kinema_bhns (bool kerrschild, const double &mass_bh, const double &sepa, double omega, double x_rot, double y_rot)
| Computes the quantities `bsn` and `pot_centri` .
void | fait_d_psi_bhns ()
| Computes the gradient of the total velocity potential .
void | extr_curv_bhns ()
| Computes `taij_auto` , `taij_quad_auto` from `shift_auto` , `lapse_auto` , `confo_auto` .
void | equilibrium_bhns (double ent_c, const double &mass_bh, const double &sepa, bool kerrschild, int mer, int mermax_ns, int mermax_potvit, int mermax_poisson, int filter_r, int filter_r_s, int filter_p_s, double relax_poisson, double relax_potvit, double thres_adapt, double resize_ns, const Tbl &fact_resize, Tbl &diff)
| Computes an equilibrium configuration.
double | velo_pot_bhns (const double &mass_bh, const double &sepa, bool kerrschild, int mermax, double precis, double relax)
| Computes the non-translational part of the velocity scalar potential by solving the continuity equation.
double | chi_rp (double radius, double phi)
| Sensitive indicator of the mass-shedding to the direction of , , .
double | radius_p (double phi)
| Radius of the star to the direction of and .
double | phi_min ()
| Azimuthal angle when the indicator of the mass-shedding takes its minimum chi_min.
double | phi_local_min (double phi_ini)
| Azimuthal angle when the indicator of the mass-shedding takes its local minimum.
void | relax_bhns (const Star_bhns &star_prev, double relax_ent, double relax_met, int mer, int fmer_met)
| Performs a relaxation on `ent` , `lapse_auto` , `shift_auto` , `confo_auto` .
void | equil_spher_bhns (double ent_c, double precis)
| Computes a spherical configuration.
Map & | set_mp ()
| Read/write of the mapping.
void | set_enthalpy (const Scalar &)
| Assignment of the enthalpy field.
void | equation_of_state ()
| Computes the proper baryon and energy density, as well as pressure from the enthalpy.
virtual void | hydro_euler ()
| Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame (`nbar`, `ener` and `press`).
virtual void | equilibrium_spher (double ent_c, double precis=1.e-14, const Tbl *pent_limit=0x0)
| Computes a spherical static configuration.
const Map & | get_mp () const
| Returns the mapping.
int | get_nzet () const
| Returns the number of domains occupied by the star.
const Eos & | get_eos () const
| Returns the equation of state.
const Scalar & | get_ent () const
| Returns the enthalpy field.
const Scalar & | get_nbar () const
| Returns the proper baryon density.
const Scalar & | get_ener () const
| Returns the proper total energy density.
const Scalar & | get_press () const
| Returns the fluid pressure.
const Scalar & | get_ener_euler () const
| Returns the total energy density with respect to the Eulerian observer.
const Scalar & | get_s_euler () const
| Returns the trace of the stress tensor in the Eulerian frame.
const Scalar & | get_gam_euler () const
| Returns the Lorentz factor between the fluid and Eulerian observers.
const Vector & | get_u_euler () const
| Returns the fluid 3-velocity with respect to the Eulerian observer.
const Tensor & | get_stress_euler () const
| Returns the spatial part of the stress-energy tensor with respect to the Eulerian observer.
const Scalar & | get_logn () const
| Returns the logarithm of the lapse N.
const Scalar & | get_nn () const
| Returns the lapse function N.
const Vector & | get_beta () const
| Returns the shift vector .
const Scalar & | get_lnq () const
const Metric & | get_gamma () const
| Returns the 3-metric .
double | ray_eq () const
| Coordinate radius at , [r_unit].
double | ray_eq_pis2 () const
| Coordinate radius at , [r_unit].
double | ray_eq_pi () const
| Coordinate radius at , [r_unit].
double | ray_eq_3pis2 () const
| Coordinate radius at , [r_unit].
double | ray_pole () const
| Coordinate radius at [r_unit].
virtual const Itbl & | l_surf () const
| Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
const Tbl & | xi_surf () const
| Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

## Protected Member Functions

virtual void | del_deriv () const
| Deletes all the derived quantities.
void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator <<).
virtual void | del_hydro_euler ()
| Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.

## Protected Attributes

Map_af | mp_aff
| Affine mapping for solving poisson's equations of metric quantities.
bool | irrotational
| `true` for an irrotational star, `false` for a corotating one
Scalar | psi0
| Scalar potential of the non-translational part of fluid 4-velocity (in the irrotational case).
Vector | d_psi
| Gradient of (in the irrotational case) (Spherical components with respect to the mapping of the star).
Vector | wit_w
| Spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.
Scalar | loggam
| Logarithm of the Lorentz factor between the fluid and the co-orbiting observer.
Vector | bsn
| 3-vector shift, divided by N , of the rotating coordinates, .
Scalar | gam
| Lorentz factor between the fluid and the co-orbiting observer.
Scalar | gam0
| Lorentz factor between the co-orbiting observer and the Eulerian one.
Scalar | pot_centri
| Centrifugal potential.
Scalar | lapconf_auto
| Lapconf function generated by the star.
Scalar | lapconf_comp
| Lapconf function generated by the companion black hole.
Scalar | lapconf_tot
| Total lapconf function.
Scalar | lapse_auto
| Lapse function generated by the "star".
Scalar | lapse_tot
| Total lapse function.
Vector | d_lapconf_auto
| Derivative of the lapconf function generated by the star .
Vector | d_lapconf_comp
| Derivative of the lapconf function generated by the companion black hole.
Vector | shift_auto
| Shift vector generated by the star.
Vector | shift_comp
| Shift vector generated by the companion black hole.
Vector | shift_tot
| Total shift vector.
Tensor | d_shift_auto
| Derivative of the shift vector generated by the star .
Tensor | d_shift_comp
| Derivative of the shift vector generated by the companion black hole.
Scalar | confo_auto
| Conformal factor generated by the star.
Scalar | confo_comp
| Conformal factor generated by the companion black hole.
Scalar | confo_tot
| Total conformal factor.
Vector | d_confo_auto
| Derivative of the conformal factor generated by the star .
Vector | d_confo_comp
| Derivative of the conformal factor generated by the companion black hole.
Scalar | psi4
| Fourth power of the total conformal factor.
Sym_tensor | taij_auto
| Part of the extrinsic curvature tensor generated by `shift_auto` , `lapse_auto` , and `confo_auto` .
Scalar | taij_quad_auto
| Part of the scalar generated by .
Metric_flat | flat
| Flat metric defined on the mapping (Spherical components with respect to the mapping of the star ).
Scalar | ssjm1_lapconf
| Effective source at the previous step for the resolution of the Poisson equation for `lapconf_auto` .
Scalar | ssjm1_confo
| Effective source at the previous step for the resolution of the Poisson equation for `confo_auto` .
Scalar | ssjm1_khi
| Effective source at the previous step for the resolution of the Poisson equation for the scalar by means of `Map_et::poisson` .
Vector | ssjm1_wshift
| Effective source at the previous step for the resolution of the vector Poisson equation for by means of `Map_et::poisson` .
double * | p_mass_b_bhns
| Baryon mass.
double * | p_mass_g_bhns
| Gravitational mass.
Map & | mp
| Mapping associated with the star.
int | nzet
| Number of domains of `*mp` occupied by the star.
const Eos & | eos
| Equation of state of the stellar matter.
Scalar | ent
| Log-enthalpy.
Scalar | nbar
| Baryon density in the fluid frame.
Scalar | ener
| Total energy density in the fluid frame.
Scalar | press
| Fluid pressure.
Scalar | ener_euler
| Total energy density in the Eulerian frame.
Scalar | s_euler
| Trace of the stress scalar in the Eulerian frame.
Scalar | gam_euler
| Lorentz factor between the fluid and Eulerian observers.
Vector | u_euler
| Fluid 3-velocity with respect to the Eulerian observer.
Sym_tensor | stress_euler
| Spatial part of the stress-energy tensor with respect to the Eulerian observer.
Scalar | logn
| Logarithm of the lapse N .
Scalar | nn
| Lapse function N .
Vector | beta
| Shift vector.
Scalar | lnq
Metric | gamma
| 3-metric
double * | p_ray_eq
| Coordinate radius at , .
double * | p_ray_eq_pis2
| Coordinate radius at , .
double * | p_ray_eq_pi
| Coordinate radius at , .
double * | p_ray_eq_3pis2
| Coordinate radius at , .
double * | p_ray_pole
| Coordinate radius at .
Itbl * | p_l_surf
| Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .
Tbl * | p_xi_surf
| Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .
double * | p_mass_b
| Baryon mass.
double * | p_mass_g
| Gravitational mass.

## Friends

class | Bin_bhns

## Detailed Description

Class for stars in black hole-neutron star binaries.

()

Definition at line 59 of file star_bhns.h.

## Constructor & Destructor Documentation

## Star_bhns() [1/3]

Lorene::Star_bhns::Star_bhns | ( | Map & | mp_i,
|  | int | nzet_i,
|  | const Eos & | eos_i,
|  | bool | irrot_i )

Standard constructor.

Parameters

  mp_i | Mapping on which the star will be defined
  nzet_i | Number of domains occupied by the star
  eos_i | Equation of state of the stellar matter
  irrot_i | should be `true` for an irrotational star, `false` for a corotating one

Definition at line 73 of file star_bhns.C.

References bsn, confo_auto, confo_comp, confo_tot, d_confo_auto, d_confo_comp, d_lapconf_auto, d_lapconf_comp, d_psi, d_shift_auto, d_shift_comp, flat, gam, gam0, Lorene::get_bvect_cart(), irrotational, lapconf_auto, lapconf_comp, lapconf_tot, lapse_auto, lapse_tot, loggam, Lorene::Map(), mp_aff, pot_centri, psi0, psi4, set_der_0x0(), shift_auto, shift_comp, shift_tot, ssjm1_confo, ssjm1_khi, ssjm1_lapconf, ssjm1_wshift, Lorene::Star::Star(), taij_auto, taij_quad_auto, Lorene::Star::u_euler, and wit_w.

## Star_bhns() [2/3]

Lorene::Star_bhns::Star_bhns | ( | const Star_bhns & | star | ) |

Copy constructor.

Definition at line 178 of file star_bhns.C.

References bsn, confo_auto, confo_comp, confo_tot, d_confo_auto, d_confo_comp, d_lapconf_auto, d_lapconf_comp, d_psi, d_shift_auto, d_shift_comp, flat, gam, gam0, irrotational, lapconf_auto, lapconf_comp, lapconf_tot, lapse_auto, lapse_tot, loggam, mp_aff, pot_centri, psi0, psi4, set_der_0x0(), shift_auto, shift_comp, shift_tot, ssjm1_confo, ssjm1_khi, ssjm1_lapconf, ssjm1_wshift, Lorene::Star::Star(), Star_bhns(), taij_auto, taij_quad_auto, and wit_w.

## Star_bhns() [3/3]

Lorene::Star_bhns::Star_bhns | ( | Map & | mp_i,
|  | const Eos & | eos_i,
|  | FILE * | fich )

Constructor from a file (see `sauve(FILE*)` ).

Parameters

  mp_i | Mapping on which the star will be defined
  eos_i | Equation of state of the stellar matter
  fich | input file (must have been created by the function `sauve` )

Definition at line 221 of file star_bhns.C.

References bsn, confo_auto, confo_comp, confo_tot, d_confo_auto, d_confo_comp, d_lapconf_auto, d_lapconf_comp, d_psi, d_shift_auto, d_shift_comp, flat, gam, gam0, Lorene::Star::gam_euler, Lorene::get_bvect_cart(), Lorene::get_mg(), irrotational, lapconf_auto, lapconf_comp, lapconf_tot, lapse_auto, lapse_tot, loggam, Lorene::Map(), Lorene::Star::mp, mp_aff, pot_centri, psi0, psi4, set_der_0x0(), shift_auto, shift_comp, shift_tot, ssjm1_confo, ssjm1_khi, ssjm1_lapconf, ssjm1_wshift, Lorene::Star::Star(), taij_auto, taij_quad_auto, Lorene::Star::u_euler, and wit_w.

## ~Star_bhns()

Lorene::Star_bhns::~Star_bhns | ( |  | ) |

virtual

Destructor.

Definition at line 329 of file star_bhns.C.

References del_deriv().

## Member Function Documentation

## chi_rp()

double Lorene::Star_bhns::chi_rp | ( | double | radius,
|  | double | phi )

Sensitive indicator of the mass-shedding to the direction of , , .

Parameters

  radius | [input] Radial coordinate
  phi | [input] Azimuthal angle

Definition at line 61 of file star_bhns_chi.C.

References Lorene::Star::ent, Lorene::phi, Lorene::Star::ray_pole(), and Lorene::Scalar::val_point().

## del_deriv()

void Lorene::Star_bhns::del_deriv | ( |  | ) | const

protected virtual

Deletes all the derived quantities.

Reimplemented from Lorene::Star.

Definition at line 341 of file star_bhns.C.

References Lorene::Star::del_deriv(), p_mass_b_bhns, p_mass_g_bhns, and set_der_0x0().

## del_hydro_euler()

void Lorene::Star::del_hydro_euler | ( |  | ) |

protected virtual inherited

Sets to `ETATNONDEF` (undefined state) the hydrodynamical quantities relative to the Eulerian observer.

Reimplemented in Lorene::Star_bin, Lorene::Star_bin_xcts, Lorene::Star_rot, and Lorene::Star_rot_Dirac.

Definition at line 330 of file star.C.

References del_deriv(), ener_euler, gam_euler, s_euler, stress_euler, and u_euler.

## equation_of_state()

void Lorene::Star::equation_of_state | ( |  | ) |

inherited

Computes the proper baryon and energy density, as well as pressure from the enthalpy.

Definition at line 462 of file star.C.

References Lorene::Param::add_int(), Lorene::Scalar::allocate_all(), del_deriv(), ener, ent, eos, Lorene::Mg3d::get_grille3d(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), mp, nbar, nzet, press, Lorene::Mtbl::set(), Lorene::Scalar::set_domain(), Lorene::Mtbl::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Scalar::std_spectral_base(), Lorene::Mtbl::t, and Lorene::Grille3d::x.

## equil_spher_bhns()

void Lorene::Star_bhns::equil_spher_bhns | ( | double | ent_c,
|  | double | precis )

Computes a spherical configuration.

Parameters

  ent_c | [input] Central enthalpy
  precis | [input] precision

Definition at line 64 of file star_bhns_spher.C.

References Lorene::Scalar::annule(), confo_auto, confo_tot, Lorene::diffrel(), Lorene::Star::ener, Lorene::Star::ener_euler, Lorene::Star::ent, Lorene::Star::equation_of_state(), Lorene::exp(), Lorene::Star::gam_euler, Lorene::Scalar::get_dzpuis(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_af::homothetie(), Lorene::Scalar::inc_dzpuis(), Lorene::Scalar::integrale(), lapconf_auto, lapconf_tot, lapse_auto, lapse_tot, Lorene::log(), Lorene::Star::mp, Lorene::norme(), Lorene::Star::nzet, Lorene::Map_af::poisson(), Lorene::pow(), Lorene::Star::press, psi4, Lorene::Star::s_euler, Lorene::Cmp::set_etat_qcq(), shift_auto, Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), Lorene::Star::u_euler, and Lorene::Scalar::val_grid_point().

## equilibrium_bhns()

void Lorene::Star_bhns::equilibrium_bhns | ( | double | ent_c,
|  | const double & | mass_bh,
|  | const double & | sepa,
|  | bool | kerrschild,
|  | int | mer,
|  | int | mermax_ns,
|  | int | mermax_potvit,
|  | int | mermax_poisson,
|  | int | filter_r,
|  | int | filter_r_s,
|  | int | filter_p_s,
|  | double | relax_poisson,
|  | double | relax_potvit,
|  | double | thres_adapt,
|  | double | resize_ns,
|  | const Tbl & | fact_resize,
|  | Tbl & | diff )

Computes an equilibrium configuration.

Parameters

  ent_c | [input] Central enthalpy
  mass_bh | [input] BH mass in the background metric
  sepa | [input] Separation between NS and BH
  kerrschild | should be `true` for a Kerr-Schild background, `false` for a Conformally flat one
  mer | [input] Number of iteration
  mermax_ns | [input] Maximum number of iteration steps
  mermax_potvit | [input] Maximum number of steps in Map_radial::poisson_compact
  mermax_poisson | [input] Maximum number of steps in poisson scalar
  filter_r | [input] No. points to be deleted for (r): lap,conf
  filter_r_s | [input] No. points to be deleted for (r): shift
  filter_p_s | [input] No. points to be deleted for (phi): shift
  relax_poisson | [input] Relaxation factor in poisson scalar
  relax_potvit | [input] Relaxation factor in Map_radial::poisson_compact
  thres_adapt | [input] Threshold on dH/dr for the adaptation of the mapping
  resize_ns | [input] Resize factor for the first shell
  fact_resize | [input] 1-D `Tbl` for the input of some factors : \ `fact(0)` : A resizing factor for the first shell
  diff | [output] 1-D `Tbl` for the storage of some error indicators :

Definition at line 67 of file star_bhns_equilibrium.C.

References Lorene::abs(), Lorene::Param::add_cmp_mod(), Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::Param::add_tenseur_mod(), Lorene::Scalar::annule(), Lorene::Tensor::annule(), Lorene::Cmp::annule_hard(), chi_rp(), confo_auto, confo_tot, d_confo_auto, d_lapconf_auto, Lorene::Tensor::dec_dzpuis(), Lorene::diffrel(), Lorene::Star::ener_euler, Lorene::Star::ent, Lorene::Star::equation_of_state(), Lorene::exp(), Lorene::Scalar::filtre(), flat, gam, gam0, Lorene::Scalar::get_dzpuis(), Lorene::Scalar::get_etat(), Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_et::homothetie(), hydro_euler_bhns(), Lorene::Scalar::inc_dzpuis(), irrotational, lapconf_auto, lapconf_comp, Lorene::Scalar::laplacian(), Lorene::log(), loggam, Lorene::max(), Lorene::Star::mp, Lorene::Star::nzet, phi_min(), Lorene::Scalar::poisson(), Lorene::Tenseur::poisson_vect(), pot_centri, Lorene::pow(), Lorene::Star::press, radius_p(), Lorene::Star::ray_eq_pi(), Lorene::Star::ray_pole(), Lorene::Star::s_euler, Lorene::Tbl::set(), Lorene::Tenseur::set(), Lorene::Vector::set(), Lorene::Cmp::set_etat_qcq(), Lorene::Scalar::set_etat_qcq(), Lorene::Tbl::set_etat_qcq(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tensor::set_etat_qcq(), Lorene::Tenseur::set_std_base(), shift_auto, Lorene::sqrt(), ssjm1_confo, ssjm1_khi, ssjm1_lapconf, ssjm1_wshift, Lorene::Scalar::std_spectral_base(), Lorene::Vector::std_spectral_base(), taij_auto, taij_quad_auto, Lorene::Star::u_euler, and velo_pot_bhns().

## equilibrium_spher()

void Lorene::Star::equilibrium_spher | ( | double | ent_c,
|  | double | precis = 1.e-14,
|  | const Tbl * | pent_limit = 0x0 )

virtual inherited

Computes a spherical static configuration.

Parameters

  ent_c | [input] central value of the enthalpy
  precis | [input] threshold in the relative difference between the enthalpy fields of two consecutive steps to stop the iterative procedure (default value: 1.e-14)
  ent_limit | [input] : array of enthalpy values to be set at the boundaries between the domains; if set to 0x0 (default), the initial values will be kept.

Definition at line 95 of file star_equil_spher.C.

References Lorene::Map_et::adapt(), Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Param::add_tbl(), Lorene::diffrel(), Lorene::Map_af::dsdr(), Lorene::Scalar::dsdr(), ener, ener_euler, ent, equation_of_state(), Lorene::exp(), gam_euler, gamma, Lorene::Map_af::get_alpha(), Lorene::Map_et::get_alpha(), Lorene::Map_af::get_beta(), Lorene::Map_et::get_beta(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map_af::homothetie(), Lorene::Scalar::integrale(), logn, mass_b(), mass_g(), mp, nn, Lorene::norme(), nzet, Lorene::Map_af::poisson(), press, s_euler, Lorene::Tensor::set(), Lorene::Map_af::set_alpha(), Lorene::Map_af::set_beta(), Lorene::Scalar::set_dzpuis(), Lorene::Cmp::set_etat_qcq(), Lorene::Tensor::set_etat_zero(), Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), u_euler, and Lorene::Scalar::val_grid_point().

## extr_curv_bhns()

void Lorene::Star_bhns::extr_curv_bhns | ( |  | ) |

Computes `taij_auto` , `taij_quad_auto` from `shift_auto` , `lapse_auto` , `confo_auto` .

Definition at line 60 of file star_bhns_extr_curv.C.

References confo_auto, d_shift_auto, flat, lapconf_auto, Lorene::Star::mp, Lorene::pow(), Lorene::Tensor::set(), Lorene::Tensor::set_etat_qcq(), Lorene::Scalar::std_spectral_base(), Lorene::Tensor::std_spectral_base(), taij_auto, and taij_quad_auto.

## fait_d_psi_bhns()

void Lorene::Star_bhns::fait_d_psi_bhns | ( |  | ) |

Computes the gradient of the total velocity potential .

Definition at line 535 of file star_bhns.C.

References bsn, d_psi, Lorene::Star::ent, Lorene::exp(), Lorene::Star::gam_euler, irrotational, Lorene::Star::mp, Lorene::Star::nzet, psi0, psi4, Lorene::Vector::set(), Lorene::Valeur::set_base(), Lorene::Tensor::set_etat_qcq(), Lorene::Vector::std_spectral_base(), and Lorene::Cmp::va.

## get_beta()

const Vector & Lorene::Star::get_beta | ( |  | ) | const

inline inherited

Returns the shift vector .

Definition at line 402 of file star.h.

References beta.

## get_bsn()

const Vector & Lorene::Star_bhns::get_bsn | ( |  | ) | const

inline

Returns the shift vector, divided by N , of the rotating coordinates, .

(Spherical components with respect to the mapping of the star)

Definition at line 327 of file star_bhns.h.

References bsn.

## get_confo_auto()

const Scalar & Lorene::Star_bhns::get_confo_auto | ( |  | ) | const

inline

Returns the part of the conformal factor generated by the star.

Definition at line 383 of file star_bhns.h.

References confo_auto.

## get_confo_comp()

const Scalar & Lorene::Star_bhns::get_confo_comp | ( |  | ) | const

inline

Returns the part of the conformal factor generated by the companion black hole.

Definition at line 388 of file star_bhns.h.

References confo_comp.

## get_confo_tot()

const Scalar & Lorene::Star_bhns::get_confo_tot | ( |  | ) | const

inline

Returns the total conformal factor.

Definition at line 391 of file star_bhns.h.

References confo_tot.

## get_d_confo_auto()

const Vector & Lorene::Star_bhns::get_d_confo_auto | ( |  | ) | const

inline

Returns the derivative of the conformal factor generated by the star.

Definition at line 396 of file star_bhns.h.

References d_confo_auto.

## get_d_confo_comp()

const Vector & Lorene::Star_bhns::get_d_confo_comp | ( |  | ) | const

inline

Returns the derivative of the conformal factor generated by the companion black hole.

Definition at line 401 of file star_bhns.h.

References d_confo_comp.

## get_d_lapconf_auto()

const Vector & Lorene::Star_bhns::get_d_lapconf_auto | ( |  | ) | const

inline

Returns the derivative of the lapse function generated by the star.

Definition at line 356 of file star_bhns.h.

References d_lapconf_auto.

## get_d_lapconf_comp()

const Vector & Lorene::Star_bhns::get_d_lapconf_comp | ( |  | ) | const

inline

Returns the derivative of the lapse function generated by the companion black hole.

Definition at line 361 of file star_bhns.h.

References d_lapconf_comp.

## get_d_psi()

const Vector & Lorene::Star_bhns::get_d_psi | ( |  | ) | const

inline

Returns the covariant derivative of the velocity potential (Spherical components with respect to the mapping of the star).

Definition at line 310 of file star_bhns.h.

References d_psi.

## get_d_shift_auto()

const Tensor & Lorene::Star_bhns::get_d_shift_auto | ( |  | ) | const

inline

Returns the derivative of the shift vector generated by the star.

Definition at line 375 of file star_bhns.h.

References d_shift_auto.

## get_d_shift_comp()

const Tensor & Lorene::Star_bhns::get_d_shift_comp | ( |  | ) | const

inline

Returns the derivative of the shift vector generated by the companion black hole.

Definition at line 380 of file star_bhns.h.

References d_shift_comp.

## get_ener()

const Scalar & Lorene::Star::get_ener | ( |  | ) | const

inline inherited

Returns the proper total energy density.

Definition at line 370 of file star.h.

References ener.

## get_ener_euler()

const Scalar & Lorene::Star::get_ener_euler | ( |  | ) | const

inline inherited

Returns the total energy density with respect to the Eulerian observer.

Definition at line 376 of file star.h.

References ener_euler.

## get_ent()

const Scalar & Lorene::Star::get_ent | ( |  | ) | const

inline inherited

Returns the enthalpy field.

Definition at line 364 of file star.h.

References ent.

## get_eos()

const Eos & Lorene::Star::get_eos | ( |  | ) | const

inline inherited

Returns the equation of state.

Definition at line 361 of file star.h.

References eos.

## get_gam()

const Scalar & Lorene::Star_bhns::get_gam | ( |  | ) | const

inline

Returns the Lorentz factor gam.

Definition at line 330 of file star_bhns.h.

References gam.

## get_gam0()

const Scalar & Lorene::Star_bhns::get_gam0 | ( |  | ) | const

inline

Returns the Lorentz factor gam0.

Definition at line 333 of file star_bhns.h.

References gam0.

## get_gam_euler()

const Scalar & Lorene::Star::get_gam_euler | ( |  | ) | const

inline inherited

Returns the Lorentz factor between the fluid and Eulerian observers.

Definition at line 382 of file star.h.

References gam_euler.

## get_gamma()

const Metric & Lorene::Star::get_gamma | ( |  | ) | const

inline inherited

Returns the 3-metric .

Definition at line 409 of file star.h.

References gamma.

## get_lapconf_auto()

const Scalar & Lorene::Star_bhns::get_lapconf_auto | ( |  | ) | const

inline

Returns the part of the lapconf function generated by the star.

Definition at line 339 of file star_bhns.h.

References lapconf_auto.

## get_lapconf_comp()

const Scalar & Lorene::Star_bhns::get_lapconf_comp | ( |  | ) | const

inline

Returns the part of the lapconf function generated by the companion black hole.

Definition at line 344 of file star_bhns.h.

References lapconf_comp.

## get_lapconf_tot()

const Scalar & Lorene::Star_bhns::get_lapconf_tot | ( |  | ) | const

inline

Returns the total lapconf function.

Definition at line 347 of file star_bhns.h.

References lapconf_tot.

## get_lapse_auto()

const Scalar & Lorene::Star_bhns::get_lapse_auto | ( |  | ) | const

inline

Definition at line 350 of file star_bhns.h.

## get_lapse_tot()

const Scalar & Lorene::Star_bhns::get_lapse_tot | ( |  | ) | const

inline

Returns the total lapse function.

Definition at line 353 of file star_bhns.h.

References lapse_tot.

## get_lnq()

const Scalar & Lorene::Star::get_lnq | ( |  | ) | const

inline inherited

Definition at line 406 of file star.h.

## get_loggam()

const Scalar & Lorene::Star_bhns::get_loggam | ( |  | ) | const

inline

Returns the logarithm of the Lorentz factor between the fluid and the co-orbiting observer.

Definition at line 321 of file star_bhns.h.

References loggam.

## get_logn()

const Scalar & Lorene::Star::get_logn | ( |  | ) | const

inline inherited

Returns the logarithm of the lapse N.

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 396 of file star.h.

References logn.

## get_mp()

const Map & Lorene::Star::get_mp | ( |  | ) | const

inline inherited

Returns the mapping.

Definition at line 355 of file star.h.

References Lorene::Map(), and mp.

## get_nbar()

const Scalar & Lorene::Star::get_nbar | ( |  | ) | const

inline inherited

Returns the proper baryon density.

Definition at line 367 of file star.h.

References nbar.

## get_nn()

const Scalar & Lorene::Star::get_nn | ( |  | ) | const

inline inherited

Returns the lapse function N.

Definition at line 399 of file star.h.

References nn.

## get_nzet()

int Lorene::Star::get_nzet | ( |  | ) | const

inline inherited

Returns the number of domains occupied by the star.

Definition at line 358 of file star.h.

References nzet.

## get_pot_centri()

const Scalar & Lorene::Star_bhns::get_pot_centri | ( |  | ) | const

inline

Returns the centrifugal potential.

Definition at line 336 of file star_bhns.h.

References pot_centri.

## get_press()

const Scalar & Lorene::Star::get_press | ( |  | ) | const

inline inherited

Returns the fluid pressure.

Definition at line 373 of file star.h.

References press.

## get_psi0()

const Scalar & Lorene::Star_bhns::get_psi0 | ( |  | ) | const

inline

Returns the non-translational part of the velocity potential.

Definition at line 305 of file star_bhns.h.

References psi0.

## get_psi4()

const Scalar & Lorene::Star_bhns::get_psi4 | ( |  | ) | const

inline

Returns the fourth power of the total conformal factor.

Definition at line 404 of file star_bhns.h.

References psi4.

## get_s_euler()

const Scalar & Lorene::Star::get_s_euler | ( |  | ) | const

inline inherited

Returns the trace of the stress tensor in the Eulerian frame.

Definition at line 379 of file star.h.

References s_euler.

## get_shift_auto()

const Vector & Lorene::Star_bhns::get_shift_auto | ( |  | ) | const

inline

Returns the part of the shift vector generated by the star.

Definition at line 364 of file star_bhns.h.

References shift_auto.

## get_shift_comp()

const Vector & Lorene::Star_bhns::get_shift_comp | ( |  | ) | const

inline

Returns the part of the shift vector generated by the companion black hole.

Definition at line 369 of file star_bhns.h.

References shift_comp.

## get_shift_tot()

const Vector & Lorene::Star_bhns::get_shift_tot | ( |  | ) | const

inline

Returns the part total shift vector.

Definition at line 372 of file star_bhns.h.

References shift_tot.

## get_stress_euler()

const Tensor & Lorene::Star::get_stress_euler | ( |  | ) | const

inline inherited

Returns the spatial part of the stress-energy tensor with respect to the Eulerian observer.

Definition at line 390 of file star.h.

References stress_euler.

## get_taij_auto()

const Sym_tensor & Lorene::Star_bhns::get_taij_auto | ( |  | ) | const

inline

Returns the part of the extrinsic curvature tensor generated by the neutron star part.

Definition at line 409 of file star_bhns.h.

References taij_auto.

## get_taij_quad_auto()

const Scalar & Lorene::Star_bhns::get_taij_quad_auto | ( |  | ) | const

inline

Returns the part of the scalar generated by .

Definition at line 415 of file star_bhns.h.

References taij_quad_auto.

## get_u_euler()

const Vector & Lorene::Star::get_u_euler | ( |  | ) | const

inline inherited

Returns the fluid 3-velocity with respect to the Eulerian observer.

Definition at line 385 of file star.h.

References u_euler.

## get_wit_w()

const Vector & Lorene::Star_bhns::get_wit_w | ( |  | ) | const

inline

Returns the spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.

(Spherical components with respect to the mapping of the star)

Definition at line 316 of file star_bhns.h.

References wit_w.

## hydro_euler()

void Lorene::Star::hydro_euler | ( |  | ) |

virtual inherited

Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame (`nbar`, `ener` and `press`).

Reimplemented in Lorene::Star_bin, Lorene::Star_bin_xcts, Lorene::Star_rot, Lorene::Star_rot_Dirac, and Lorene::Star_rot_Dirac_diff.

Definition at line 577 of file star.C.

## hydro_euler_bhns()

void Lorene::Star_bhns::hydro_euler_bhns | ( | bool | kerrschild,
|  | const double & | mass_bh,
|  | const double & | sepa )

Computes the hydrodynamical quantities relative to the Eulerian observer from those in the fluid frame, as well as `wit_w` and `loggam` .

The calculation is performed starting from the quantities `ent` , `ener` , `press` , `a_car` and `bsn` , which are supposed to be up to date. From these, the following fields are updated: `gam_euler` , `u_euler` , `ener_euler` , `s_euler` , `stress_euler` , `wit_w` and `loggam` .

Parameters

  kerrschild | should be `true` for a Kerr-Schild background, `false` for a Conformally flat one
  mass_bh | BH mass in the background metric
  sepa | Separation between NS and BH

Definition at line 59 of file star_bhns_hydro.C.

References bsn, d_psi, del_deriv(), Lorene::Star::ener, Lorene::Star::ener_euler, Lorene::Star::ent, Lorene::exp(), gam, gam0, Lorene::Star::gam_euler, irrotational, Lorene::log(), loggam, Lorene::Star::mp, Lorene::Star::press, psi4, Lorene::Star::s_euler, Lorene::Vector::set(), Lorene::Tensor::set_etat_qcq(), Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), Lorene::Vector::std_spectral_base(), Lorene::Star::u_euler, and wit_w.

## is_irrotational()

bool Lorene::Star_bhns::is_irrotational | ( |  | ) | const

inline

Returns `true` for an irrotational motion, `false` for a corotating one.

Definition at line 302 of file star_bhns.h.

References irrotational.

## kinema_bhns()

void Lorene::Star_bhns::kinema_bhns | ( | bool | kerrschild,
|  | const double & | mass_bh,
|  | const double & | sepa,
|  | double | omega,
|  | double | x_rot,
|  | double | y_rot )

Computes the quantities `bsn` and `pot_centri` .

The calculation is performed starting from the quantities `lapse_tot` , `shift_tot` , which are supposed to be up to date.

Parameters

  kerrschild | should be `true` for a Kerr-Schild background, `false` for a Conformally flat one
  mass_bh | BH mass in the background metric
  sepa | Separation between NS and BH
  omega | angular velocity with respect to an asymptotically inertial observer
  x_rot | absolute X coordinate of the rotation axis
  y_rot | absolute Y coordinate of the rotation axis

Definition at line 61 of file star_bhns_kinema.C.

References bsn, confo_tot, del_deriv(), gam0, lapconf_tot, Lorene::log(), Lorene::Star::mp, pot_centri, psi4, Lorene::Vector::set(), Lorene::Tensor::set_etat_qcq(), shift_tot, Lorene::sqrt(), Lorene::Scalar::std_spectral_base(), Lorene::Vector::std_spectral_base(), Lorene::xa, and Lorene::ya.

## l_surf()

const Itbl & Lorene::Star::l_surf | ( |  | ) | const

virtual inherited

Description of the stellar surface: returns a 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent`) vanishes.

Reimplemented in Lorene::Star_rot.

Definition at line 63 of file star_global.C.

References ent, mp, nzet, p_l_surf, and p_xi_surf.

## mass_b()

double Lorene::Star_bhns::mass_b | ( |  | ) | const

virtual

Baryon mass.

Implements Lorene::Star.

Definition at line 63 of file star_bhns_global.C.

References confo_tot, Lorene::Star::gam_euler, Lorene::Scalar::integrale(), Lorene::Star::nbar, Lorene::Star::p_mass_b, Lorene::pow(), and Lorene::Scalar::std_spectral_base().

## mass_b_bhns()

double Lorene::Star_bhns::mass_b_bhns | ( | bool | kerrschild,
|  | const double & | mass_bh,
|  | const double & | sepa ) const

virtual

Definition at line 86 of file star_bhns_global.C.

## mass_g()

double Lorene::Star_bhns::mass_g | ( |  | ) | const

virtual

Gravitational mass.

Implements Lorene::Star.

Definition at line 138 of file star_bhns_global.C.

## mass_g_bhns()

double Lorene::Star_bhns::mass_g_bhns | ( |  | ) | const

virtual

Definition at line 147 of file star_bhns_global.C.

## operator=()

void Lorene::Star_bhns::operator= | ( | const Star_bhns & | star | ) |

Assignment to another Star_bhns.

Definition at line 368 of file star_bhns.C.

References bsn, confo_auto, confo_comp, confo_tot, d_confo_auto, d_confo_comp, d_lapconf_auto, d_lapconf_comp, d_psi, d_shift_auto, d_shift_comp, del_deriv(), flat, gam, gam0, irrotational, lapconf_auto, lapconf_comp, lapconf_tot, lapse_auto, lapse_tot, loggam, mp_aff, Lorene::Star::operator=(), pot_centri, psi0, psi4, shift_auto, shift_comp, shift_tot, ssjm1_confo, ssjm1_khi, ssjm1_lapconf, ssjm1_wshift, Star_bhns(), taij_auto, taij_quad_auto, and wit_w.

## operator>>()

ostream & Lorene::Star_bhns::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >> (virtual function called by the operator <<).

Reimplemented from Lorene::Star.

Definition at line 495 of file star_bhns.C.

References confo_tot, Lorene::Star::ent, lapse_tot, Lorene::Star::ray_eq(), Lorene::Star::ray_eq_pi(), Lorene::Star::ray_eq_pis2(), Lorene::Star::ray_pole(), and shift_tot.

## phi_local_min()

double Lorene::Star_bhns::phi_local_min | ( | double | phi_ini | ) |

Azimuthal angle when the indicator of the mass-shedding takes its local minimum.

Parameters

  phi_ini | [input] Initial azumuthal angle to search minimum

Definition at line 145 of file star_bhns_chi.C.

References chi_rp(), and radius_p().

## phi_min()

double Lorene::Star_bhns::phi_min | ( |  | ) |

Azimuthal angle when the indicator of the mass-shedding takes its minimum chi_min.

Definition at line 83 of file star_bhns_chi.C.

References chi_rp(), Lorene::Mg3d::get_np(), Lorene::Star::mp, Lorene::phi, phi_local_min(), radius_p(), Lorene::Tbl::set(), and Lorene::Tbl::set_etat_qcq().

## radius_p()

double Lorene::Star_bhns::radius_p | ( | double | phi | ) |

Radius of the star to the direction of and .

Parameters

  phi | [input] Azimuthal angle

Definition at line 74 of file star_bhns_chi.C.

References Lorene::Star::mp, Lorene::Star::nzet, and Lorene::phi.

## ray_eq()

double Lorene::Star::ray_eq | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 108 of file star_global.C.

References Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq, Lorene::phi, and xi_surf().

## ray_eq_3pis2()

double Lorene::Star::ray_eq_3pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 233 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_3pis2, Lorene::phi, ray_eq_pis2(), and xi_surf().

## ray_eq_pi()

double Lorene::Star::ray_eq_pi | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 186 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pi, Lorene::phi, ray_eq(), and xi_surf().

## ray_eq_pis2()

double Lorene::Star::ray_eq_pis2 | ( |  | ) | const

inherited

Coordinate radius at , [r_unit].

Definition at line 138 of file star_global.C.

References Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_type_p(), Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_eq_pis2, Lorene::phi, and xi_surf().

## ray_pole()

double Lorene::Star::ray_pole | ( |  | ) | const

inherited

Coordinate radius at [r_unit].

Definition at line 278 of file star_global.C.

References Lorene::Mg3d::get_type_t(), l_surf(), mp, p_ray_pole, Lorene::phi, and xi_surf().

## relax_bhns()

void Lorene::Star_bhns::relax_bhns | ( | const Star_bhns & | star_prev,
|  | double | relax_ent,
|  | double | relax_met,
|  | int | mer,
|  | int | fmer_met )

Performs a relaxation on `ent` , `lapse_auto` , `shift_auto` , `confo_auto` .

Parameters

  star_prev | [input] star at the previous step
  relax_ent | [input] Relaxation factor for `ent`
  relax_met | [input] Relaxation factor for `lapse_auto` , `shift_auto` , `confo_auto` , only if ``(merfmer_met=0) .
  mer | [input] Step number
  fmer_met | [input] Step interval between metric updates

Definition at line 594 of file star_bhns.C.

References confo_auto, del_deriv(), Lorene::Star::ent, Lorene::Star::equation_of_state(), lapconf_auto, shift_auto, and Star_bhns().

## sauve()

void Lorene::Star_bhns::sauve | ( | FILE * | fich | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Star.

Definition at line 470 of file star_bhns.C.

References confo_auto, Lorene::Star::gam_euler, irrotational, lapconf_auto, psi0, Lorene::Star::sauve(), shift_auto, ssjm1_confo, ssjm1_khi, ssjm1_lapconf, and ssjm1_wshift.

## set_confo_auto()

Scalar & Lorene::Star_bhns::set_confo_auto | ( |  | ) |

Read/write of the conformal factor generated by the neutron star.

Definition at line 449 of file star_bhns.C.

References confo_auto, and del_deriv().

## set_confo_comp()

Scalar & Lorene::Star_bhns::set_confo_comp | ( |  | ) |

Read/write of the conformal factor generated by the companion black hole.

Definition at line 456 of file star_bhns.C.

References confo_comp, and del_deriv().

## set_der_0x0()

void Lorene::Star_bhns::set_der_0x0 | ( |  | ) | const

protected virtual

Sets to `0x0` all the pointers on derived quantities.

Reimplemented from Lorene::Star.

Definition at line 352 of file star_bhns.C.

References p_mass_b_bhns, p_mass_g_bhns, and Lorene::Star::set_der_0x0().

## set_enthalpy()

void Lorene::Star::set_enthalpy | ( | const Scalar & | ent_i | ) |

inherited

Assignment of the enthalpy field.

Definition at line 379 of file star.C.

References del_deriv(), ent, and equation_of_state().

## set_lapconf_auto()

Scalar & Lorene::Star_bhns::set_lapconf_auto | ( |  | ) |

Read/write of the lapconf function generated by the neutron star.

Definition at line 421 of file star_bhns.C.

References del_deriv(), and lapconf_auto.

## set_lapconf_comp()

Scalar & Lorene::Star_bhns::set_lapconf_comp | ( |  | ) |

Read/write of the lapconf function generated by the companion black hole.

Definition at line 428 of file star_bhns.C.

References del_deriv(), and lapconf_comp.

## set_mp()

Map & Lorene::Star::set_mp | ( |  | ) |

inline inherited

Read/write of the mapping.

Definition at line 322 of file star.h.

References Lorene::Map(), and mp.

## set_pot_centri()

Scalar & Lorene::Star_bhns::set_pot_centri | ( |  | ) |

Read/write the centrifugal potential.

Definition at line 414 of file star_bhns.C.

References del_deriv(), and pot_centri.

## set_shift_auto()

Vector & Lorene::Star_bhns::set_shift_auto | ( |  | ) |

Read/write of the shift vector generated by the neutron star.

Definition at line 435 of file star_bhns.C.

References del_deriv(), and shift_auto.

## set_shift_comp()

Vector & Lorene::Star_bhns::set_shift_comp | ( |  | ) |

Read/write of the shift vector generated by the companion black hole.

Definition at line 442 of file star_bhns.C.

References del_deriv(), and shift_comp.

## update_met_der_comp_bhns()

void Lorene::Star_bhns::update_met_der_comp_bhns | ( | const Hole_bhns & | hole | ) |

Computes derivative of metric quantities from the companion black hole.

Parameters

  hole | companion black hole

Definition at line 60 of file star_bhns_upmetr_der.C.

References d_confo_comp, d_lapconf_comp, d_shift_comp, Lorene::Tensor::dec_dzpuis(), del_deriv(), Lorene::Hole_bhns::get_d_confo_auto(), Lorene::Hole_bhns::get_d_lapconf_auto(), and Lorene::Hole_bhns::get_d_shift_auto().

## update_metric_bhns()

void Lorene::Star_bhns::update_metric_bhns | ( | const Hole_bhns & | hole,
|  | const Star_bhns & | star_prev,
|  | double | relax )

Computes metric coefficients from known potentials with relaxation when the companion is a black hole.

The calculation is performed starting from the quantities `lapse_auto` , `shift_auto` , `confo_auto` , `comp.lapse_auto` , `comp.confo_auto` which are supposed to be up to date. From these, the following fields are updated: `lapse_comp` , `lapse_tot`, `confo_comp`, `confo_tot` , `psi4` ,

Parameters

  hole | companion black hole
  star_prev | previous value of the star
  relax | relaxation parameter

Definition at line 60 of file star_bhns_upmetr.C.

References Lorene::Vector::change_triad(), confo_auto, confo_comp, confo_tot, d_confo_auto, d_lapconf_auto, d_shift_auto, del_deriv(), Lorene::Hole_bhns::get_confo_auto(), Lorene::Hole_bhns::get_lapconf_auto(), Lorene::Black_hole::get_mp(), Lorene::Hole_bhns::get_shift_auto(), Lorene::Tensor::get_triad(), lapconf_auto, lapconf_comp, lapconf_tot, lapse_auto, lapse_tot, Lorene::Map(), Lorene::Star::mp, Lorene::pow(), psi4, shift_auto, shift_comp, shift_tot, and Star_bhns().

## velo_pot_bhns()

double Lorene::Star_bhns::velo_pot_bhns | ( | const double & | mass_bh,
|  | const double & | sepa,
|  | bool | kerrschild,
|  | int | mermax,
|  | double | precis,
|  | double | relax )

Computes the non-translational part of the velocity scalar potential by solving the continuity equation.

Parameters

  mass_bh | [input] BH mass in the background metric
  sepa | [input] Separation between NS and BH
  kerrschild | should be `true` for a Kerr-Schild background, `false` for a Conformally flat one
  mermax | [input] Maximum number of steps in the iteration
  precis | [input] Required precision: the iteration will be stopped when the relative difference on between two successive steps is lower than `precis` .
  relax | [input] Relaxation factor.

Returns
  Relative error of the resolution obtained by comparing the operator acting on the solution with the source.

Definition at line 67 of file star_bhns_vel_pot.C.

References Lorene::Param::add_double(), Lorene::Param::add_int(), Lorene::Param::add_int_mod(), Lorene::Scalar::annule(), bsn, Lorene::Vector::change_triad(), confo_tot, Lorene::contract(), d_confo_auto, d_confo_comp, d_lapconf_auto, d_lapconf_comp, d_psi, Lorene::Scalar::derive_con(), Lorene::diffrel(), Lorene::Star::ent, Lorene::Star::eos, Lorene::exp(), flat, Lorene::Star::gam_euler, Lorene::Tensor::get_triad(), lapconf_tot, Lorene::log(), Lorene::Star::mp, Lorene::norme(), Lorene::Star::nzet, psi0, psi4, Lorene::Tenseur::set(), Lorene::Vector::set(), Lorene::Scalar::set_domain(), Lorene::Tenseur::set_etat_qcq(), Lorene::Tensor::set_etat_qcq(), Lorene::Scalar::set_spectral_va(), Lorene::Tensor::set_triad(), Lorene::Scalar::std_spectral_base(), Lorene::Vector::std_spectral_base(), Lorene::Cmp::va, Lorene::Valeur::ylm(), and Lorene::Valeur::ylm_i().

## xi_surf()

const Tbl & Lorene::Star::xi_surf | ( |  | ) | const

inherited

Description of the stellar surface: returns a 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

The stellar surface is defined as the location where the enthalpy (member `ent`) vanishes.

Definition at line 89 of file star_global.C.

References l_surf(), p_l_surf, and p_xi_surf.

## Friends And Related Symbol Documentation

## Bin_bhns

friend class Bin_bhns

friend

Definition at line 626 of file star_bhns.h.

## Member Data Documentation

## beta

Vector Lorene::Star::beta

protected inherited

Shift vector.

Definition at line 228 of file star.h.

## bsn

Vector Lorene::Star_bhns::bsn

protected

3-vector shift, divided by N , of the rotating coordinates, .

(Spherical components with respect to the mapping of the star)

Definition at line 99 of file star_bhns.h.

## confo_auto

Scalar Lorene::Star_bhns::confo_auto

protected

Conformal factor generated by the star.

Definition at line 157 of file star_bhns.h.

## confo_comp

Scalar Lorene::Star_bhns::confo_comp

protected

Conformal factor generated by the companion black hole.

Definition at line 160 of file star_bhns.h.

## confo_tot

Scalar Lorene::Star_bhns::confo_tot

protected

Total conformal factor.

Definition at line 163 of file star_bhns.h.

## d_confo_auto

Vector Lorene::Star_bhns::d_confo_auto

protected

Derivative of the conformal factor generated by the star .

Definition at line 168 of file star_bhns.h.

## d_confo_comp

Vector Lorene::Star_bhns::d_confo_comp

protected

Derivative of the conformal factor generated by the companion black hole.

Definition at line 173 of file star_bhns.h.

## d_lapconf_auto

Vector Lorene::Star_bhns::d_lapconf_auto

protected

Derivative of the lapconf function generated by the star .

Definition at line 130 of file star_bhns.h.

## d_lapconf_comp

Vector Lorene::Star_bhns::d_lapconf_comp

protected

Derivative of the lapconf function generated by the companion black hole.

Definition at line 135 of file star_bhns.h.

## d_psi

Vector Lorene::Star_bhns::d_psi

protected

Gradient of (in the irrotational case) (Spherical components with respect to the mapping of the star).

Definition at line 82 of file star_bhns.h.

## d_shift_auto

Tensor Lorene::Star_bhns::d_shift_auto

protected

Derivative of the shift vector generated by the star .

Definition at line 149 of file star_bhns.h.

## d_shift_comp

Tensor Lorene::Star_bhns::d_shift_comp

protected

Derivative of the shift vector generated by the companion black hole.

Definition at line 154 of file star_bhns.h.

## ener

Scalar Lorene::Star::ener

protected inherited

Total energy density in the fluid frame.

Definition at line 193 of file star.h.

## ener_euler

Scalar Lorene::Star::ener_euler

protected inherited

Total energy density in the Eulerian frame.

Definition at line 198 of file star.h.

## ent

Scalar Lorene::Star::ent

protected inherited

Log-enthalpy.

Definition at line 190 of file star.h.

## eos

const Eos& Lorene::Star::eos

protected inherited

Equation of state of the stellar matter.

Definition at line 185 of file star.h.

## flat

Metric_flat Lorene::Star_bhns::flat

protected

Flat metric defined on the mapping (Spherical components with respect to the mapping of the star ).

Definition at line 192 of file star_bhns.h.

## gam

Scalar Lorene::Star_bhns::gam

protected

Lorentz factor between the fluid and the co-orbiting observer.

Definition at line 102 of file star_bhns.h.

## gam0

Scalar Lorene::Star_bhns::gam0

protected

Lorentz factor between the co-orbiting observer and the Eulerian one.

Definition at line 107 of file star_bhns.h.

## gam_euler

Scalar Lorene::Star::gam_euler

protected inherited

Lorentz factor between the fluid and Eulerian observers.

Definition at line 204 of file star.h.

## gamma

Metric Lorene::Star::gamma

protected inherited

3-metric

Definition at line 235 of file star.h.

## irrotational

bool Lorene::Star_bhns::irrotational

protected

`true` for an irrotational star, `false` for a corotating one

Definition at line 72 of file star_bhns.h.

## lapconf_auto

Scalar Lorene::Star_bhns::lapconf_auto

protected

Lapconf function generated by the star.

Definition at line 113 of file star_bhns.h.

## lapconf_comp

Scalar Lorene::Star_bhns::lapconf_comp

protected

Lapconf function generated by the companion black hole.

Definition at line 116 of file star_bhns.h.

## lapconf_tot

Scalar Lorene::Star_bhns::lapconf_tot

protected

Total lapconf function.

Definition at line 119 of file star_bhns.h.

## lapse_auto

Scalar Lorene::Star_bhns::lapse_auto

protected

Lapse function generated by the "star".

Definition at line 122 of file star_bhns.h.

## lapse_tot

Scalar Lorene::Star_bhns::lapse_tot

protected

Total lapse function.

Definition at line 125 of file star_bhns.h.

## lnq

Scalar Lorene::Star::lnq

protected inherited

Definition at line 232 of file star.h.

## loggam

Scalar Lorene::Star_bhns::loggam

protected

Logarithm of the Lorentz factor between the fluid and the co-orbiting observer.

Definition at line 93 of file star_bhns.h.

## logn

Scalar Lorene::Star::logn

protected inherited

Logarithm of the lapse N .

In the Newtonian case, this is the Newtonian gravitational potential (in units of ).

Definition at line 222 of file star.h.

## mp

Map& Lorene::Star::mp

protected inherited

Mapping associated with the star.

Definition at line 180 of file star.h.

## mp_aff

Map_af Lorene::Star_bhns::mp_aff

protected

Affine mapping for solving poisson's equations of metric quantities.

Definition at line 67 of file star_bhns.h.

## nbar

Scalar Lorene::Star::nbar

protected inherited

Baryon density in the fluid frame.

Definition at line 192 of file star.h.

## nn

Scalar Lorene::Star::nn

protected inherited

Lapse function N .

Definition at line 225 of file star.h.

## nzet

int Lorene::Star::nzet

protected inherited

Number of domains of `*mp` occupied by the star.

Definition at line 183 of file star.h.

## p_l_surf

Itbl* Lorene::Star::p_l_surf

mutable protected inherited

Description of the stellar surface: 2-D `Itbl` containing the values of the domain index l on the surface at the collocation points in .

Definition at line 260 of file star.h.

## p_mass_b

double* Lorene::Star::p_mass_b

mutable protected inherited

Baryon mass.

Definition at line 268 of file star.h.

## p_mass_b_bhns

double* Lorene::Star_bhns::p_mass_b_bhns

mutable protected

Baryon mass.

Definition at line 225 of file star_bhns.h.

## p_mass_g

double* Lorene::Star::p_mass_g

mutable protected inherited

Gravitational mass.

Definition at line 269 of file star.h.

## p_mass_g_bhns

double* Lorene::Star_bhns::p_mass_g_bhns

mutable protected

Gravitational mass.

Definition at line 226 of file star_bhns.h.

## p_ray_eq

double* Lorene::Star::p_ray_eq

mutable protected inherited

Coordinate radius at , .

Definition at line 242 of file star.h.

## p_ray_eq_3pis2

double* Lorene::Star::p_ray_eq_3pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 251 of file star.h.

## p_ray_eq_pi

double* Lorene::Star::p_ray_eq_pi

mutable protected inherited

Coordinate radius at , .

Definition at line 248 of file star.h.

## p_ray_eq_pis2

double* Lorene::Star::p_ray_eq_pis2

mutable protected inherited

Coordinate radius at , .

Definition at line 245 of file star.h.

## p_ray_pole

double* Lorene::Star::p_ray_pole

mutable protected inherited

Coordinate radius at .

Definition at line 254 of file star.h.

## p_xi_surf

Tbl* Lorene::Star::p_xi_surf

mutable protected inherited

Description of the stellar surface: 2-D `Tbl` containing the values of the radial coordinate on the surface at the collocation points in .

Definition at line 266 of file star.h.

## pot_centri

Scalar Lorene::Star_bhns::pot_centri

protected

Centrifugal potential.

Definition at line 110 of file star_bhns.h.

## press

Scalar Lorene::Star::press

protected inherited

Fluid pressure.

Definition at line 194 of file star.h.

## psi0

Scalar Lorene::Star_bhns::psi0

protected

Scalar potential of the non-translational part of fluid 4-velocity (in the irrotational case).

Definition at line 77 of file star_bhns.h.

## psi4

Scalar Lorene::Star_bhns::psi4

protected

Fourth power of the total conformal factor.

Definition at line 176 of file star_bhns.h.

## s_euler

Scalar Lorene::Star::s_euler

protected inherited

Trace of the stress scalar in the Eulerian frame.

Definition at line 201 of file star.h.

## shift_auto

Vector Lorene::Star_bhns::shift_auto

protected

Shift vector generated by the star.

Definition at line 138 of file star_bhns.h.

## shift_comp

Vector Lorene::Star_bhns::shift_comp

protected

Shift vector generated by the companion black hole.

Definition at line 141 of file star_bhns.h.

## shift_tot

Vector Lorene::Star_bhns::shift_tot

protected

Total shift vector.

Definition at line 144 of file star_bhns.h.

## ssjm1_confo

Scalar Lorene::Star_bhns::ssjm1_confo

protected

Effective source at the previous step for the resolution of the Poisson equation for `confo_auto` .

Definition at line 202 of file star_bhns.h.

## ssjm1_khi

Scalar Lorene::Star_bhns::ssjm1_khi

protected

Effective source at the previous step for the resolution of the Poisson equation for the scalar by means of `Map_et::poisson` .

is an intermediate quantity for the resolution of the elliptic equation for the shift vector

Definition at line 210 of file star_bhns.h.

## ssjm1_lapconf

Scalar Lorene::Star_bhns::ssjm1_lapconf

protected

Effective source at the previous step for the resolution of the Poisson equation for `lapconf_auto` .

Definition at line 197 of file star_bhns.h.

## ssjm1_wshift

Vector Lorene::Star_bhns::ssjm1_wshift

protected

Effective source at the previous step for the resolution of the vector Poisson equation for by means of `Map_et::poisson` .

is an intermediate quantity for the resolution of the elliptic equation for the shift vector (Components with respect to the Cartesian triad associated with the mapping `mp` )

Definition at line 220 of file star_bhns.h.

## stress_euler

Sym_tensor Lorene::Star::stress_euler

protected inherited

Spatial part of the stress-energy tensor with respect to the Eulerian observer.

Definition at line 212 of file star.h.

## taij_auto

Sym_tensor Lorene::Star_bhns::taij_auto

protected

Part of the extrinsic curvature tensor generated by `shift_auto` , `lapse_auto` , and `confo_auto` .

Definition at line 182 of file star_bhns.h.

## taij_quad_auto

Scalar Lorene::Star_bhns::taij_quad_auto

protected

Part of the scalar generated by .

Definition at line 187 of file star_bhns.h.

## u_euler

Vector Lorene::Star::u_euler

protected inherited

Fluid 3-velocity with respect to the Eulerian observer.

Definition at line 207 of file star.h.

## wit_w

Vector Lorene::Star_bhns::wit_w

protected

Spatial projection of the fluid 3-velocity with respect to the co-orbiting observer.

(Spherical components with respect to the mapping of the star)

Definition at line 88 of file star_bhns.h.

The documentation for this class was generated from the following files:

- star_bhns.h
- star_bhns.C
- star_bhns_chi.C
- star_bhns_equilibrium.C
- star_bhns_extr_curv.C
- star_bhns_global.C
- star_bhns_hydro.C
- star_bhns_kinema.C
- star_bhns_spher.C
- star_bhns_upmetr.C
- star_bhns_upmetr_der.C
- star_bhns_vel_pot.C